    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------
    028     * CategoryDatasetHandler.java
    029     * ---------------------------
    030     * (C) Copyright 2003-2005, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: CategoryDatasetHandler.java,v 1.3.2.1 2005/10/25 21:36:10 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 23-Jan-2003 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data.xml;
    044
    045    import org.jfree.data.category.CategoryDataset;
    046    import org.jfree.data.category.DefaultCategoryDataset;
    047    import org.xml.sax.Attributes;
    048    import org.xml.sax.SAXException;
    049    import org.xml.sax.helpers.DefaultHandler;
    050
    051    /**
    052     * A SAX handler for reading a {@link CategoryDataset} from an XML file.
    053     */
    054    public class CategoryDatasetHandler extends RootHandler implements DatasetTags {
    055
    056        /** The dataset under construction. */
    057        private DefaultCategoryDataset dataset;
    058
    059        /**
    060         * Creates a new handler.
    061         */
    062        public CategoryDatasetHandler() {
    063            this.dataset = null;
    064        }
    065
    066        /**
    067         * Returns the dataset.
    068         *
    069         * @return The dataset.
    070         */
    071        public CategoryDataset getDataset() {
    072            return this.dataset;
    073        }
    074
    075        /**
    076         * Adds an item to the dataset.
    077         *
    078         * @param rowKey  the row key.
    079         * @param columnKey  the column key.
    080         * @param value  the value.
    081         */
    082        public void addItem(Comparable rowKey, Comparable columnKey, Number value) {
    083            this.dataset.addValue(value, rowKey, columnKey);
    084        }
    085
    086        /**
    087         * The start of an element.
    088         *
    089         * @param namespaceURI  the namespace.
    090         * @param localName  the element name.
    091         * @param qName  the element name.
    092         * @param atts  the element attributes.
    093         *
    094         * @throws SAXException for errors.
    095         */
    096        public void startElement(String namespaceURI,
    097                                 String localName,
    098                                 String qName,
    099                                 Attributes atts) throws SAXException {
    100
    101            DefaultHandler current = getCurrentHandler();
    102            if (current != this) {
    103                current.startElement(namespaceURI, localName, qName, atts);
    104            }
    105            else if (qName.equals(CATEGORYDATASET_TAG)) {
    106                this.dataset = new DefaultCategoryDataset();
    107            }
    108            else if (qName.equals(SERIES_TAG)) {
    109                CategorySeriesHandler subhandler = new CategorySeriesHandler(this);
    110                getSubHandlers().push(subhandler);
    111                subhandler.startElement(namespaceURI, localName, qName, atts);
    112            }
    113            else {
    114                throw new SAXException("Element not recognised: " + qName);
    115            }
    116
    117        }
    118
    119        /**
    120         * The end of an element.
    121         *
    122         * @param namespaceURI  the namespace.
    123         * @param localName  the element name.
    124         * @param qName  the element name.
    125         *
    126         * @throws SAXException for errors.
    127         */
    128        public void endElement(String namespaceURI,
    129                               String localName,
    130                               String qName) throws SAXException {
    131
    132            DefaultHandler current = getCurrentHandler();
    133            if (current != this) {
    134                current.endElement(namespaceURI, localName, qName);
    135            }
    136
    137        }
    138
    139    }